# dict查找的性能远远大于list
# 在list中随着list数据的增大，查找时间会增大
# 在dict中查找元素，不会随着dict的增大而增大
# 1. dict的key或者set的值，都必须是可以hash的
# dict采用hash值的方式存储，所以dict、set的key，一定要是可以计算hash值的对象（如字符串），list不可以计算hash值，所以不可以作为dict的key
# 不可变对象，都是可hash的，如str、fronzenset、tuple，自己实现的类（实现__hash__的魔法函数）
# 2. dict的内存花销大，但是查询速度快。自己定义的对象，或者python内部的对象，都是用dict包装的
# 3. dict的存储属性和元素添加顺序有关（但两个key的hash值相同时，需要解决冲突，给后添加的key做偏移，所以先添加的key，会先占用位置，后添加的key，可能会因为解决hash冲突而偏移存储到其他的位置
# 4. 添加数据有可能改变已有数据的顺序（hash表空间小于1/3时，申请新的空间，将原有的数据搬迁，位置有可能会改变）

# python在一开始申请hash表空间的时候，只会申请一块比较小的空间
# 在hash表空间剩余小于1/3的时候，python会去申请一块更大的空间，将原有的数据复制到新申请的空间中
# 当hash表空间剩余小于1/3的时候，再进行hash值计算的时候，出现hash值重复的概率会明显增大
# hash表空间一定会有一些空白的空间，这是不可避免的空间浪费（可以理解为空间换时间）
